SimplePreview = {}

SimplePreview.name = "SimplePreview"

local do_nospin = false

function SimplePreview:InventorySlot_ShowContextMenu (rowControl)
    local bag, slot = ZO_Inventory_GetBagAndIndex(rowControl)

    local link = GetItemLink(bag, slot) 

    if link and IsItemPlaceableFurniture(bag, slot) then
        zo_callLater(function ()
            AddCustomMenuItem("Preview Furnishing", function ()
                CHAT_SYSTEM:AddMessage("[SimplePreview] Previewing furnishing " .. link .. ". Exit inventory to cancel preview.")

                if SCENE_MANAGER.currentScene:GetName() == "inventory" and not SCENE_MANAGER.currentScene:HasFragment(FRAME_PLAYER_FRAGMENT) then
                    SCENE_MANAGER.scenes["inventory"]:AddFragment(FRAME_PLAYER_FRAGMENT)

                    SYSTEMS:GetObject("mainMenu"):ToggleCategory(MENU_CATEGORY_INVENTORY)

                    zo_callLater(function ()
                        SYSTEMS:GetObject("mainMenu"):ToggleCategory(MENU_CATEGORY_INVENTORY)
                        do_nospin = true

                        zo_callLater(function ()
                             SYSTEMS:GetObject("itemPreview"):PreviewInventoryItemAsFurniture(bag, slot)                           
                        end, 150)
                    end, 50)
                else
                    SYSTEMS:GetObject("itemPreview"):PreviewInventoryItemAsFurniture(bag, slot)
                end
            end, MENU_ADD_OPTION_LABEL)
            ShowMenu(self)
        end, 50)
    end
end

function SimplePreview:Initialize()
    ZO_PreHook('ZO_InventorySlot_ShowContextMenu', function (rowControl) SimplePreview:InventorySlot_ShowContextMenu(rowControl) end)

    SCENE_MANAGER.scenes["inventory"]:RegisterCallback("StateChange", function (oldState, newState)
        if newState == SCENE_HIDDEN and do_nospin then
            SCENE_MANAGER.scenes["inventory"]:RemoveFragment(FRAME_PLAYER_FRAGMENT)
            do_nospin = false
        end
    end)
end

function SimplePreview.OnAddOnLoaded(event, addonName)
  if addonName == SimplePreview.name then
    SimplePreview:Initialize()
  end
end

EVENT_MANAGER:RegisterForEvent(SimplePreview.name, EVENT_ADD_ON_LOADED, SimplePreview.OnAddOnLoaded)
